<?php
// +---------------------------------------------------------------------------+
// | Geeklog Forums Migration Script							               |
// | Version 0.9 date: June 28,2003                                            |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2003 by the following author                                |
// | Script Author: Blaine Lang       -geeklog@langfamily.ca                   |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//


// Run this script from your PUBLIC_HTML Directory

require_once("lib-common.php");

/* MIGRATION SCRIPT CONFIG VARIABLES - Useful for testing
* Testing options: 
* 1) Verbose progress messages - Set to true or false
* 2) Limit stories migrated to per topic - "Limit 100" or "" to remove limit
* 3) Delete all topics in forum before starting - Set to true or false
*/
$verbose = false;
$limit = "";
$deleteTopicsFirst = false;    // Set to true to delete all topics in the forum before migrating stories


/* DIRECTION ON HOW TO USE  
// 1) Forums need to be created before initiating the migration script
// 2) Configure $arr_migrate below to map the Topics to Migrate to the forum id.
    Hint: Clicking on a Forum - you will see the forum ID in the URL of your browser

    It is possible to use this one forum or topic at a time or all at once

// It's possible to add stories from one topic area to an existing forum - as in merge two topic areas
// You would set $deleteTopicsFirst to false and add the second topic area after migrating the first
// Enable the deleteTopicsFirst option to purge a forum - each forum defined in array will be purged.

*/

$arr_migrate = array();
$arr_migrate['Help'] = '1'; 
//$arr_migrate['Geeklog'] = '2';
//$arr_migrate['Sites'] = '3'; 

/* Uncomment this to purge all forum posts - useful if you want to repeat the migration and you have a new forum installation */
//DB_query("DELETE FROM {$_TABLES['gf_topic']}");


/* ---- END OF USER CONFIGUREABLE OPTIONS ---- */

/* Delete all records in the xref table mapping migrated stories to forum topics */
DB_query("DELETE FROM gl_storytoforum","1");   // Don't report error - such as table does not exist yet.

// Migratiion Stats
$migratedstories=0;
$migratedcomments=0;
$convertedlinks=0;
$unconvertedlinks=0;


function migrateComments($forum,$sid, $parent) {
	global $verbose,$_TABLES,$_CONF,$migratedcomments;
	$sql = DB_query("SELECT sid,date,uid,title,comment from {$_TABLES['comments']} WHERE sid = '".$sid."' ORDER BY date ASC");
	$num_comments = DB_numROWS($sql);
	if ($verbose) {
	    echo "Found $num_comments Comments to migrate for this topic";
    }
	$i = 0;
	while ( list($sid,$commentdate,$uid,$subject,$comment) = DB_fetchARRAY($sql)) {

		$sqlid = DB_query("SELECT id from {$_TABLES['gf_topic']} ORDER BY id desc LIMIT 1");
		list ($lastid) = DB_fetchARRAY($sqlid);

		// Now check to see if this story has any embedded links to other site stories - if so we may need to deal with them
		$comment = updatelinks($sid,$subject,$comment,$forum);

		$comment = prepareStringForDB($comment);
		$subject = prepareStringForDB($subject);
		$postmode = "HTML";
		$name = DB_getITEM($_TABLES['users'],'username',"uid=$uid");
		$email = DB_getITEM($_TABLES['users'],'email',"uid=$uid");
		$website = DB_getITEM($_TABLES['users'],'homepage',"uid=$uid");

		$datetime = explode(" ", $commentdate);
		$date = explode("-",$datetime[0]);
		$time = explode(":",$datetime[1]);
		$year  = ($date[0] > 1969) ? $date[0] : "2001";
		$month = $date[1];
		$day   = $date[2];
		$hour  = $time[0];
		$min   = $time[1];
		$timestamp = mktime($hour,$min,0,$month,$day,$year);
		$lastupdated = $timestamp;
		$migratedcomments++;

		DB_query("INSERT INTO {$_TABLES['gf_topic']} (forum,name,date,lastupdated, email, website, subject, comment, postmode, ip, mood, uid, pid, sticky, locked) 
			VALUES ('$forum','$name','$timestamp','$lastupdated','$email','$website','$subject','$comment','$postmode','','','$uid','$parent','0','0')");
		$i++;
	}

	DB_query("UPDATE {$_TABLES['gf_topic']} SET replies = $num_comments WHERE id=$parent");
	return $num_comments;
}

function prepareStringForDB($message,$postmode="html",$censor=TRUE,$htmlfilter=TRUE) {
	if ($censor) {
	    $message = COM_checkWords($message);
	}
    if($postmode == 'html') {
        if ($htmlfilter) {
            // Need to call addslahes again as COM_checkHTML stips it out
	        $message = addslashes(COM_checkHTML($message));
		} elseif (!get_magic_quotes_gpc() ) {
		    $message = addslashes($message);
		}	
	} else {
		if(get_magic_quotes_gpc() ) {
		    $message = htmlspecialchars($message);
		} else {	
		    $message = addslashes(htmlspecialchars($message));
		}	
	}	
	return $message;
}

function updatelinks($sid,$title,$comment,$forum) {
	global $_CONF,$_TABLES,$convertedlinks;
    // Determine the last topic id in the forum - required to create link
	$sqlid = DB_query("SELECT id from {$_TABLES['gf_topic']} ORDER BY id desc LIMIT 1");
	list ($lastid) = DB_fetchARRAY($sqlid);
	$pos = 0;
	$offset = 0;
	$commentlength = strlen($comment);
    while ($pos < $commentlength AND $offset < $commentlength) {
		$pos = strpos($comment,'article.php?story=',$offset);
		if ($pos > 0) {
			$newTopicID = $lastid + 1;
			$offset = $pos+35;
			// Check and see if the referenced story has been converted to a forum topic
			// If so then I need to replace the link in this story

			// Extract the story id from the link
			$refsid = substr($comment,$pos+18,17);
			if (!is_numeric($refsid)) {  
                // Ok try one more time -- some SID's are 17 characters long and others are 16
				// I can not assume the last character is a " as sometimes the #comment string is added
				// This is the best we can do for now
				$refsid = substr($comment,$pos+18,16);
			}
			if (is_numeric($refsid)) {
			    $sqlchk = DB_query("SELECT topicid FROM gl_storytoforum WHERE storyid = '".$refsid."'");
				if (DB_numROWS($sqlchk) > 0 ) {
					list($topicid) = DB_fetchARRAY($sqlchk);
					$forum = DB_getITEM($_TABLES['gf_topic'],"forum","id='".$topicid."'");
					$len = strpos($comment,'"',$pos) - $pos;
					if ($len > 0) {
					    $string = substr($comment,$pos,$len);
					    $comment = substr_replace($comment, "forum/viewtopic.php?forum=$forum&showtopic=$topicid",$pos,$len);
					    $convertedlinks++;
					    $newlink = "<a href='{$_CONF['site_url']}/forum/viewtopic.php?forum=$forum&showtopic=$newTopicID' target='_NEW'>here</a>";
					    echo "<br>Story: $title has a link that has been <b>converted</b> automatically. New forum post is $newlink";
					} else {
						$pos = $commentlength;
					}

				} else {
					$newlink = "<a href='{$_CONF['site_url']}/forum/viewtopic.php?forum=$forum&showtopic=$newTopicID' target='_NEW'>here</a>";
					echo "<br>Story: $title has a link that should be inspected. New forum post is $newlink";
				}
			} else {
				$newlink = "<a href='{$_CONF['site_url']}/forum/viewtopic.php?forum=$forum&showtopic=$newTopicID' target='_NEW'>here</a>";
				echo "<br>Possible Link - check new forum post is $newlink";
			}
		} else {
			break;
		}
	}
	return $comment;

}


function secondpass($forum) {
	global $_CONF,$_TABLES,$convertedlinks,$unconvertedlinks;

	$sql = DB_query("SELECT id,subject,comment from {$_TABLES['gf_topic']} where forum = $forum ORDER BY id");
	$num_topics = DB_numROWS($sql);
	echo "<p><b><font size='3'>P</font></b>rocessing second pass on Forum $forum to check links to migrated stories - $num_topics topics to check.<br>";
	while ( list($tid,$subject,$comment) = DB_fetchARRAY($sql)) {
		$pos = 0;
		$offset = 0;
		$commentlength = strlen($comment);
		while ($pos < $commentlength AND $offset < $commentlength) {
			$pos = strpos($comment,'article.php?story=',$offset);
			if ($pos > 0) {
				$offset = $pos+35;
				// Check and see if the referenced story has been converted to a forum topic
				// If so then I need to replace the link in this story
				// Extract the story id from the link
				$refsid = substr($comment,$pos+18,17);
				if (!is_numeric($refsid)) {  
					// Ok try one more time -- some SID's are 17 characters long and others are 16
					// I can not assume the last character is a " as sometimes the #comment string is added
					// This is the best we can do for now
					$refsid = substr($comment,$pos+18,16);
				}
				if (is_numeric($refsid)) {
					$sqlchk = DB_query("SELECT topicid FROM gl_storytoforum WHERE storyid = '".$refsid."'");
					if (DB_numROWS($sqlchk) > 0 ) {
						list($topicid) = DB_fetchARRAY($sqlchk);
						$forum = DB_getITEM($_TABLES['gf_topic'],"forum","id='".$topicid."'");
						$len = strpos($comment,'"',$pos) - $pos;
						if ($len > 0) {
						    $string = substr($comment,$pos,$len);
						    $fixedcomment = substr_replace($comment, "forum/viewtopic.php?forum=$forum&showtopic=$topicid",$pos,$len);
        				    $fixedcomment = prepareStringForDB($fixedcomment);
						    $convertedlinks++;
	                        DB_query("UPDATE {$_TABLES['gf_topic']} SET comment = '{$fixedcomment}' WHERE id='{$tid}'");
						    $newlink = "<a href='{$_CONF['site_url']}/forum/viewtopic.php?forum=$forum&showtopic=$tid' target='_NEW'>here</a>";
						    echo "<br>Story: $subject has a link that has been <b>converted</b> automatically. New forum post is $newlink";
						} else {
						    $pos = $commentlength;
					}
					} else {
                        $unconvertedlinks++;
						$newlink = "<a href='{$_CONF['site_url']}/forum/viewtopic.php?forum=$forum&showtopic=$tid' target='_NEW'>here</a>";
						echo "<br>Forum topic: $subject has a link that should be inspected. Forum post is $newlink";
					}
				} else {
					$newlink = "<a href='{$_CONF['site_url']}/forum/viewtopic.php?forum=$forum&showtopic=$tid' target='_NEW'>here</a>";
					echo "<br>Possible Link - Check Forum post $newlink";
				}
			} else {
				break;
			}
		}
	}
	return $comment;

}


// MAIN CODE


// Create migration table for reference mappping if it does not exist.
 
$sql = "CREATE TABLE gl_storytoforum (
  storyid varchar(32) NOT NULL default '',
  topicid varchar(32) NOT NULL default ''
) TYPE=MyISAM ";
DB_query($sql,"1");   // Don't stop on error - such as table aleady exists

echo "<h1>Geeklog Story Migration Script - Version 0.9</h1>";

foreach ($arr_migrate as $topic => $forum) {

    if($deleteTopicsFirst) {
        DB_query("DELETE FROM {$_TABLES['gf_topic']} WHERE forum = $forum");
    }

	$sql = DB_query("SELECT sid,tid,date,uid,title,introtext,bodytext,hits from {$_TABLES['stories']} WHERE tid = '".$topic."' ORDER BY sid $limit");

	//$sql = DB_query("SELECT sid,tid,date,uid,title,introtext,bodytext,hits from {$_TABLES['stories']} WHERE tid = '".$topic."' AND sid > '20030520070600239' ORDER BY sid $limit");
	
	$num_stories = DB_numROWS($sql);
	echo "<p><b><font size='3'>R</font></b>eading all articles for the <b>$topic</b> topic.<br>";
	echo "Found $num_stories Topics to migrate<hr>";
	$i = 0;
	$num_posts = 0;
	while ( list($sid,$tid,$storydate,$uid,$subject,$introtext,$bodytext,$hits) = DB_fetchARRAY($sql)) {
		
		$comment = $introtext . $bodytext;

		// Now check to see if this story has any embedded links to other site stories - if so we may need to deal with them
		$comment = updatelinks($sid,$title,$comment,$forum);

		$comment = prepareStringForDB($comment);
		$subject = prepareStringForDB($subject);
		$postmode = "HTML";
		$name = DB_getITEM($_TABLES['users'],'username',"uid=$uid");
		$email = DB_getITEM($_TABLES['users'],'email',"uid=$uid");
		$website = DB_getITEM($_TABLES['users'],'homepage',"uid=$uid");

		$datetime = explode(" ", $storydate);
		$date = explode("-",$datetime[0]);
		$time = explode(":",$datetime[1]);
		$year  = ($date[0] > 1969) ? $date[0] : "2001";
		$month = $date[1];
		$day   = $date[2];
		$hour  = $time[0];
		$min   = $time[1];
		$timestamp = mktime($hour,$min,0,$month,$day,$year);

		DB_query("INSERT INTO {$_TABLES['gf_topic']} (forum,name,date,lastupdated, email, website, subject, comment, views, postmode, ip, mood, uid, pid, sticky, locked) 
			VALUES ('$forum','$name','$timestamp','$timestamp','$email','$website','$subject','$comment','$hits','$postmode','','','$uid','0','0','0')");
		$parent = DB_insertID();
		$sqlchk = DB_query("SELECT topicid FROM gl_storytoforum WHERE storyid = '".$sid."'");
        if (DB_numROWS($sqlchk) > 0 ) {
			DB_QUERY("UPDATE gl_storytoforum SET topicid = $parent WHERE storyid='".$sid."'");
		} else {
			DB_query("INSERT INTO gl_storytoforum (storyid,topicid) VALUES ('$sid','$parent')");
        }
		$i++;
		if ($verbose) {
		    echo "<br>Topic $i: $subject.  ";
        }
		$comments = migrateComments($forum,$sid, $parent);
		$num_posts = $num_posts + $comments;
		$migratedstories++;

	}

	$num_posts = $num_posts + $i;

	echo "<p>Completed ... Migrated $num_stories topics and $num_posts posts.";

}

// Now perform a second pass thru migrated forum topics looking for links to stories that have been migrated to forum topics

echo "<h2>Starting second pass to check for any links that need to be repaired</h2>";

reset ($arr_migrate);
foreach ($arr_migrate as $topic => $forum) {
    secondpass($forum);
}

echo "<HR><h1>F I N  A L    S T A T S</h1>";
echo "<br>Number of stories migrated:  $migratedstories";
echo "<br>Number of comments migrated: $migratedcomments";
echo "<br>Number of links converted:  $convertedlinks";
echo "<br>Number of links to be checked:  $unconvertedlinks";


?>